CPU, TPOOL_NTHREADS=4
;
; WRF-CHEM
;
;
; Specify window size
nxpix=958L
nypix=720L

SETPLOT='Z'
;read,'setplot?',setplot

if setplot eq 'Z' then begin
;-------------------------------------------
set_plot,'Z'
device,set_resolution=[nxpix,nypix],z_buffer=0
win_nx=!d.x_size
win_ny=!d.y_size

;--------------------------------------------
; Insert the main script
;--------------------------------------------
endif
; set color table
  loadct,45,file='color_ck.tbl'
  !p.background=254.
  !p.color=255.
mcolor=byte(!p.color)
mcolor=fix(mcolor)
if mcolor eq 0 then mcolor=255
col1=mcolor
icmm1=mcolor-1
icmm2=mcolor-2
if setplot eq 'x' then begin
   lc=mcolor
   window,4,xsize=nxpix,ysize=nypix
   device,retain=2,decomposed=0
endif
gmt=[$
'00z',$
'06z',$
'12z',$
'18z'$
]
hours=[$
'00Z',$
'06Z',$
'12Z',$
'18Z'$
]
nhour=n_elements(gmt)
openr,10,'gfsout.fil'
nfiles=0l
readf,10,nfiles
icount=0l
for nf=0,nfiles-1 do begin
datedir=''
readf,10,datedir
syr=strmid(datedir,0,4)
smn=strmid(datedir,4,2)
sdy=strmid(datedir,6,2)
netcdf_dir='/iliad/proxy/lenzen/ccm3/REALTIME/NCEP_TRUNC/'+syr+'/'
idir=netcdf_dir

for nh=0,nhour-1 do begin
gfsout='d'+syr+smn+sdy+'.'+gmt(nh)+'.ncep.gaus.nc'
nc_file_id=ncdf_open(netcdf_dir+gfsout,/nowrite)
glob_info=ncdf_inquire(nc_file_id)
natt=glob_info.ngatts
for idim=0,glob_info.ndims-1 do begin
    ncdf_diminq, nc_file_id, idim, name, dim
    print,'dimension ',idim,' ',name,' ',dim
;dimension        0 lat         1536
;dimension        1 lon         3072
;dimension        2 lev           64
;dimension        3 levp           65
;dimension        4 time            1
;dimension        5 DAteStrLen           19
;dimension        6 ar4            4
;dimension        7 nvcoord            2
if name eq 'lon' then nc=dim
if name eq 'lat' then nr=dim
if name eq 'lev' then nl=dim
if name eq 'levp' then nlp=dim
endfor
for ivar=0,glob_info.nvars-1 do begin
    result=ncdf_varinq(nc_file_id,ivar)
    print,'variable ',ivar,result.name,result.datatype,result.ndims
endfor
;variable        0latFLOAT           1
;variable        1lonFLOAT           1
;variable        2levFLOAT           1
;variable        3wlongFLOAT           1
;variable        4NVCOORDLONG           0
;variable        5IDVCLONG           0
;variable        6IDSLLONG           0
;variable        7NCEPQSATLONG           0
;variable        8VCOORD1FLOAT           1
;variable        9VCOORD2FLOAT           1
;variable       10VCFLOAT           2
;variable       11NRRFLOAT           0
;variable       12NCCFLOAT           0
;variable       13emslpFLOAT           3
;variable       14spFLOAT           3
;variable       15szFLOAT           3
;variable       16TFLOAT           4
;variable       17QFLOAT           4
;variable       18UFLOAT           4
;variable       19VFLOAT           4
;variable       20OZNFLOAT           4
;variable       21CLDWFLOAT           4
;variable       22YEARLONG           0
;variable       23MMDDHHLONG           0
;variable       24CDATELONG           0
;variable       25FHOURLONG           0
;variable       26HEADIDATELONG           1
     ncdf_varget,nc_file_id,'VCOORD1',vcoord1
     ncdf_varget,nc_file_id,'VCOORD2',vcoord2
     ncdf_varget,nc_file_id,'VC',vcoord

     ncdf_varget,nc_file_id,'lon',xlon
     ncdf_varget,nc_file_id,'lat',xlat
     ncdf_varget,nc_file_id,'sz',zsfc
     ncdf_varget,nc_file_id,'sp',psfc
     ncdf_varget,nc_file_id,'T',t
     ncdf_varget,nc_file_id,'U',u
     ncdf_varget,nc_file_id,'V',v
     ncdf_varget,nc_file_id,'Q',q

; close netCDF file
;
    ncdf_close,nc_file_id
help,vcoord1,vcoord2,vcoord
psolid=fltarr(nc,nr,nlp)
pdash=fltarr(nc,nr,nl)
delp=fltarr(nc,nr,nl)
;
; save time by only compute the rest for the domain of interest
;
index=where(xlon ge 125. and xlon le 129.)
nval=n_elements(index)
imin=index(0)
imax=index(nval-1)
index=where(xlat ge 36. and xlat le 39.)
nval=n_elements(index)
jmin=index(0)
jmax=index(nval-1)

for l=0,nlp-1 do begin
for i=imin,imax do begin
for j=jmin,jmax do begin
psolid(i,j,l)=vcoord1(l)/100.+vcoord2(l)*psfc(i,j)
if l ge 1 then begin
pdash(i,j,l-1)=.5*(psolid(i,j,l-1)+psolid(i,j,l))
delp(i,j,l-1)=psolid(i,j,l)-psolid(i,j,l-1)
endif
endfor
endfor
endfor
rgas=287.04  ;J/K/kg
rhu=100.*pdash/(rgas*t)
;
; get hydrostatic height by integrating from surface
; note: delp is positive
;
zsolid=fltarr(nc,nr,nlp)
zdash=fltarr(nc,nr,nl)
for i=imin,imax do begin
for j=jmin,jmax do begin
zsolid(i,j,nlp-1)=zsfc(i,j)
for l=nlp-2,1,-1 do begin
zsolid(i,j,l)=zsolid(i,j,l+1)+100.*delp(i,j,l-1)/(rhu(i,j,l-1)*9.8)
zdash(i,j,l-1)=.5*(zsolid(i,j,l)+zsolid(i,j,l+1))
endfor
endfor
endfor
print,'zdash ',max(zdash),min(zdash)
tpbl=fltarr(nc,nr)
upbl=fltarr(nc,nr)
vpbl=fltarr(nc,nr)
qpbl=fltarr(nc,nr)
for i=imin,imax do begin
for j=jmin,jmax do begin
zdum=reform(zdash(i,j,*),nl)
zindex=where(zdum le zsfc(i,j)+1000.)
tpbl(i,j)=total(t(i,j,zindex))/(1.*n_elements(zindex))
upbl(i,j)=total(u(i,j,zindex))/(1.*n_elements(zindex))
vpbl(i,j)=total(v(i,j,zindex))/(1.*n_elements(zindex))
qpbl(i,j)=1000.*total(q(i,j,zindex))/(1.*n_elements(zindex))
endfor
endfor
t=tpbl
u=upbl
v=vpbl
q=qpbl

dylab=datedir
syear=strmid(datedir,0,4)
smon=strmid(datedir,4,2)
sday=strmid(datedir,6,2)

iyear=long(strmid(datedir,0,4))
imon=long(strmid(datedir,4,2))
iday=long(strmid(datedir,6,2))
fxpng=syear+smon+sday+'_'+hours(nh)
label=smon+'/'+sday+'/'+syear+' '+hours(nh)
      lev=6.+6.*findgen(31)/30.


pdir='./'
; Specify window size
nxpix=958L
nypix=720L

if setplot eq 'Z' then begin
;-------------------------------------------
set_plot,'Z'
device,set_resolution=[nxpix,nypix],z_buffer=0
win_nx=!d.x_size
win_ny=!d.y_size

;--------------------------------------------
; Insert the main script
;--------------------------------------------
endif
if setplot eq 'ps' then begin
   lc=0
   set_plot,'ps'
   xsize=nxpix/100.
   ysize=nypix/100.
   !p.font=0
   device,/landscape,bits=8,filename=pdir+'GFS_'+fxpng+'.Q.13km.ps'
   device,/color
   device,/inch,xoff=4.25-ysize/2.,yoff=5.5+xsize/2.,$
          xsize=xsize,ysize=ysize
   !p.thick=1
   !p.charsize=1.
endif
mcolor=255
icmm2=mcolor-2
icmm1=mcolor-1
; PLOT
        !noeras=1
        !type=2^2+2^3
        !p.thick=1.5
level=lev
xmin=min(xlon)
xmax=max(xlon)
ymin=min(xlat)
ymax=max(xlat)
xmin=126.
xmax=128.
ymax=38.
ymin=37.
print,xmin,xmax,ymin,ymax
set_viewport,.1,.9,.1,.9
color=.2*icmm2+.8*icmm2*findgen(31)/30.
title=' GFS 13km SFC-1km WV (g/kg) '+label
!p.charsize=1
!p.thick=2.
erase
;map_set,38,-97,0,/lambert,/us,/continents,limit=[22,-122,50,-70],/HIRES,$
map_set,/us,/continents,limit=[ymin,xmin,ymax,xmax],/HIRES,$
title=title,color=mcolor
loadct,39
daymap=q
contour,daymap,xlon,xlat,/overplot,level=level,/cell_fill,min_val=-999.,c_color=color
mapcolor=mcolor
map_set,/us,/continents,/noeras,limit=[ymin,xmin,ymax,xmax],/HIRES,$
/grid,latdel=1,londel=1,label=1,color=0
maxmag=20.
vcolor=0.
nhem=0
drawvectors,nc,nr,xlon,xlat,u,v,maxmag,nhem,vcolor
;Waypoint,                                                          Latitude,       Longitude
;Truax Field,    						   43.136464,      -89.345783
;Sheboygan County Municipal Airport,                               43.768872,      -87.852911
;Zion Ground Site,                                                 42.467689,      -87.810036
;Zion Offshore,                                                    42.467306,      -87.643986
;Zion Background,                                                  42.538050,      -88.668203
;Sheboygan Ground Site,                                            43.746214,      -87.707881
;Sheboygan Offshore,                                               43.746069,      -87.646194
;Sheboygan Background,                                             43.668344,      -88.113811
;Zion Background,                                                  42.538050,      -88.668203
;Kohler-Andrae Monitor,                                            43.667347,      -87.716269
;Kohler-Andrae Offshore,                                           43.666722,      -87.653539
;Oak Creek Offshore Waypoint,                                      42.843542,      -87.663944
;Milwaukee Offshore,                                               43.020800,      -87.652575
;Chicago offshore Waypoint,                                        42.247467,      -87.251989
;Chicago Background Waypoint,                                      42.445283,      -88.439006
;Oak Creek Coal Fired Power Plant,                                 42.844444,      -87.828611
;Milwaukee Background Waypoint,                                    42.841758,      -88.222867
;Waukesha Monitor,                                                 43.020108,      -88.215083
;Port Washington Gas Fired (or Coal/Gas) Generating Station,       43.384431,      -87.869714
;Port Washington Offshore,                                         43.384539,      -87.807222
;Port Washington Background Waypoint,                              43.494975,      -88.111892
;Edgewater Coal Fired Generating Station,                          43.715556,      -87.706389
;!psym=4
;!p.thick=2
;oplot,lon_station(3:nstation-1),lat_station(3:nstation-1),color=0
;xyouts,lon_station(3:nstation-1),lat_station(3:nstation-1),lab_station(3:nstation-1)
!p.thick=1
; color bar
!p.charsize=1.
        !psym=0
        imin=min(level)
        imax=max(level)
        set_viewport,.1,.45,.09,.1
        !type=2^2+2^3+2^6
        plot,[imin,imax],[0,0],yrange=[0,10],xrange=[imin,imax],$
        xtitle='(g/kg)',/noeras,color=mcolor
        ybox=[0,10,10,0,0]
        x2=imin
        dx=(imax-imin)/float(.8*icmm2)
loadct,39
        for j=2*icmm2/10,icmm2 do begin
            xbox=[x2,x2,x2+dx,x2+dx,x2]
            polyfill,xbox,ybox,color=j
            x2=x2+dx
        endfor
; color bar
image=tvrd(0,0,win_nx,win_ny)
image_byt=bytscl(image,min=0,max=255)
;transparent=bytarr(256)+255B
;transparent(255:255)=0
tvlct,r,g,b,/get

write_png,pdir+'WRF_YSU-NOAH_3nests_'+fxpng+'.Qpbl.13km.png',image_byt,r,g,b
endfor  ; end loop over nh hours
endfor  ; end loop over nf files
end
